<script>
import scenarios from "@/assets/scenarios.js";
import cards from "@/assets/monsters.js";
import { locations, locationsMapping } from "@/assets/locations.js";

export default {
  data() {
    return {
      scenarios: scenarios,
      currentScenario: "Сценарий не выбран",
      cardsAvailable: [],
      cardsDrawn: [],
      showDropdown: false,
      allCards: cards.map((e) => e.name),
      selectedCard: "Поиск монстра",
      currentLocations: [],
    };
  },

  watch: {
    selectedCard(newValue, oldValue) {
      console.log(oldValue, newValue);
      if (newValue !== null) {
        // Check if some scenario is selected
        if (this.currentScenario !== "Сценарий не выбран") {
          // Get the card from the current card pool
          const foundCard = this.cardsAvailable.find(
            (c) => c.name === newValue
          );
          console.log(foundCard);
          if (foundCard !== null) {
            this.cardsAvailable = this.cardsAvailable.filter(
              (c) => c !== foundCard
            );
            this.addCard(newValue);
          } else {
            this.addCard(newValue);
          }
        } else {
          // Add card from the common pool
          this.addCard(newValue);
        }
      }
    },
  },

  methods: {
    selectScenario(scenario) {
      this.cardsDrawn = [];
      this.currentScenario = scenario;
      this.showDropdown = false;
      this.cardsAvailable = cards.filter((c) =>
        c.scenarios.includes(this.currentScenario)
      );
      // Add additinal metadata for each card
      this.cardsAvailable.forEach((element, index) => {
        element.src = this.cardFront(element);
        element.front = true;
        element.damage = 0;
        this.cardsAvailable[index] = element;
      });
      this.shuffleCards();
      // Prepare locations
      this.currentLocations = [];
      console.log(this.currentScenario);
      for (let [location, sublocations] of Object.entries(locations)) {
        if (locationsMapping[this.currentScenario].includes(location)) {
          sublocations.forEach((sl) =>
            this.currentLocations.push(`${location} ${sl}`)
          );
        }
      }
      console.log(this.currentLocations);
    },
    rollMonster() {
      let newCard = this.cardsAvailable.pop();
      console.log(newCard);
      this.cardsDrawn.push(newCard);
    },
    shuffleCards() {
      for (let i = this.cardsAvailable.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1));
        [this.cardsAvailable[i], this.cardsAvailable[j]] = [
          this.cardsAvailable[j],
          this.cardsAvailable[i],
        ];
      }
    },
    cardFront(card) {
      return `./monsters/front/${card.name}.jpg`;
    },
    cardBack(card) {
      return `./monsters/back/${card.name}.jpg`;
    },
    reverseCard(card) {
      if (card.front) {
        card.src = this.cardBack(card);
        card.front = false;
      } else {
        card.src = this.cardFront(card);
        card.front = true;
      }
    },
    removeCard(card) {
      this.cardsDrawn = this.cardsDrawn.filter((item) => item !== card);
      this.cardsAvailable.unshift(card);
    },
    addCard(name) {
      console.log(name);
      let foundCards = cards.filter((card) => card.name == name);
      console.log(foundCards);
      for (let card of foundCards) {
        card.src = this.cardFront(card);
        card.front = true;
        card.damage = 0;
        this.cardsDrawn.push(card);
        break;
      }
    },
  },
};
</script>

<template>
  <section class="hero is-danger">
    <div class="hero-body">
      <p class="title">Arkham monster roller</p>
      <p class="subtitle">
        {{ currentScenario }}
        <br />
        Всего карт: {{ cardsAvailable.length }}
        <br />
        Активных карт: {{ cardsDrawn.length }}
      </p>
    </div>
  </section>

  <div class="block"></div>

  <div class="columns is-mobile">
    <div class="column">
      <div class="field is-grouped">
        <div class="control">
          <div class="dropdown" :class="{ 'is-active': showDropdown }">
            <div class="dropdown-trigger">
              <button
                class="button"
                aria-haspopup="true"
                aria-controls="scenarios"
                @click="showDropdown = !showDropdown"
              >
                <span>Сценарии</span>
                <span class="icon is-small">
                  <i class="fas fa-angle-down"></i>
                </span>
              </button>
            </div>
            <div class="dropdown-menu" id="scenarios" role="menu">
              <div class="dropdown-content">
                <a
                  v-for="scenario in scenarios"
                  v-bind:key="scenario"
                  @click="selectScenario(scenario)"
                  href="#"
                  class="dropdown-item"
                  >{{ scenario }}</a
                >
              </div>
            </div>
          </div>
        </div>

        <div class="control">
          <v-select :options="allCards" v-model="selectedCard"></v-select>
        </div>
      </div>

      <div class="block"></div>

      <button
        v-if="cardsAvailable.length > 0"
        @click="rollMonster()"
        class="button is-primary"
      >
        Новый монстр
      </button>

      <!-- Micro thumbnail grid for monster preview: click to go to monster -->

      <div class="block"></div>

      <div id="gallery" class="title is-ancestor">
        <div class="tile" v-for="card in cardsDrawn" v-bind:key="card">
          <a :href="'#' + card.name">
            <figure class="image is-64x64">
              <img :src="card.src" />
            </figure>
          </a>
        </div>
      </div>

      <div class="block"></div>

      <template v-for="card in cardsDrawn" v-bind:key="card">
        <figure class="image">
          <a href="#gallery">
            <img :id="card.name" :src="card.src" />
          </a>
        </figure>
        <div class="field is-grouped">
          <p class="control">
            <button @click="reverseCard(card)" class="button is-warning">
              Развернуть
            </button>
          </p>
          <p class="control">
            <button @click="removeCard(card)" class="button is-danger">
              Убрать
            </button>
          </p>
          <div class="control">
            <button class="button" @click="card.damage--">
              <span class="icon is-small">
                <i class="fas fa-minus"></i>
              </span>
            </button>
          </div>
          <div class="control" style="width: 10%">
            <input class="input is-danger" type="number" :value="card.damage" />
          </div>
          <div class="control">
            <button class="button" @click="card.damage++">
              <span class="icon is-small">
                <i class="fas fa-plus"></i>
              </span>
            </button>
          </div>
        </div>
        <v-select :options="currentLocations" label="Локация"></v-select>
        <input class="input" type="text" placeholder="Заметки" />
        <div class="block"></div>
      </template>

      <div class="block"></div>

      <button
        v-if="cardsAvailable.length > 0 && cardsDrawn.length > 0"
        @click="rollMonster()"
        class="button is-primary"
      >
        Новый монстр
      </button>
    </div>
  </div>
</template>

<style scoped>
* {
  --vs-controls-color: #664cc3;
  --vs-border-color: #664cc3;

  --vs-dropdown-bg: #282c34;
  --vs-dropdown-color: #cc99cd;
  --vs-dropdown-option-color: #cc99cd;

  --vs-selected-bg: #664cc3;
  --vs-selected-color: #eeeeee;

  --vs-search-input-color: #eeeeee;

  --vs-dropdown-option--active-bg: #664cc3;
  --vs-dropdown-option--active-color: #eeeeee;

  /* --vs-dropdown-min-width: 260px; */
}
</style>
